searchNodes=[{"doc":"HTTP2-compliant wrapper for sending iOS and Android push notifications. Getting Started Check the module documentation for your push notification service. Pigeon.ADM - Amazon Android. Pigeon.APNS - Apple iOS. Pigeon.FCM - Firebase Cloud Messaging v1 API. Pigeon.LegacyFCM - Firebase Cloud Messaging Legacy API. Creating Dynamic Runtime Dispatchers Pigeon can spin up dynamic dispatchers for a variety of advanced use-cases, such as supporting dozens of dispatcher configurations or custom connection pools. See Pigeon.Dispatcher for instructions. Writing a Custom Dispatcher Adapter Want to write a Pigeon adapter for an unsupported push notification service? See Pigeon.Adapter for instructions.","ref":"Pigeon.html","title":"Pigeon","type":"module"},{"doc":"Returns the configured default pool size for Pigeon dispatchers. To customize this value, include the following in your config/config.exs: config :pigeon , :default_pool_size , 5","ref":"Pigeon.html#default_pool_size/0","title":"Pigeon.default_pool_size/0","type":"function"},{"doc":"Returns the configured JSON encoding library for Pigeon. To customize the JSON library, include the following in your config/config.exs: config :pigeon , :json_library , Jason","ref":"Pigeon.html#json_library/0","title":"Pigeon.json_library/0","type":"function"},{"doc":"","ref":"Pigeon.html#push/3","title":"Pigeon.push/3","type":"function"},{"doc":"","ref":"Pigeon.html#t:notification/0","title":"Pigeon.notification/0","type":"type"},{"doc":"Async callback for push notifications response. Examples handler = fn ( % Pigeon.ADM.Notification { response : response } ) -&gt; case response do :success -&gt; Logger . debug &quot;Push successful!&quot; :unregistered -&gt; Logger . error &quot;Bad device token!&quot; _error -&gt; Logger . error &quot;Some other error happened.&quot; end end n = Pigeon.ADM.Notification . new ( &quot;token&quot; , %{ &quot;message&quot; =&gt; &quot;test&quot; } ) Pigeon.ADM . push ( n , on_response : handler )","ref":"Pigeon.html#t:on_response/0","title":"Pigeon.on_response/0","type":"type"},{"doc":"Options for sending push notifications. :on_response - Optional async callback triggered on receipt of push. See on_response/0 :timeout - Push timeout. Defaults to 5000ms.","ref":"Pigeon.html#t:push_opts/0","title":"Pigeon.push_opts/0","type":"type"},{"doc":"Adapter behaviour for Pigeon.Dispatcher push workers. Pigeon.Adapter closely resembles GenServer behaviour, as dispatchers are GenServers under the hood. Example Adapter defmodule Pigeon.Sandbox do import Pigeon.Tasks , only : [ process_on_response : 1 ] @behaviour Pigeon.Adapter @impl true def init ( opts \\ [ ] ) do { :ok , opts } end @impl true def handle_info ( _msg , state ) do { :noreply , state } end @impl true def handle_push ( %{ response : nil } = notification , state ) do process_on_response ( %{ notification | response : :success } ) { :noreply , state } end def handle_push ( notification , state ) do process_on_response ( notification ) { :noreply , state } end end","ref":"Pigeon.Adapter.html","title":"Pigeon.Adapter","type":"behaviour"},{"doc":"Invoked to handle all other messages.","ref":"Pigeon.Adapter.html#c:handle_info/2","title":"Pigeon.Adapter.handle_info/2","type":"callback"},{"doc":"Invoked to handle push notifications.","ref":"Pigeon.Adapter.html#c:handle_push/2","title":"Pigeon.Adapter.handle_push/2","type":"callback"},{"doc":"Invoked when the server is started. Return value should be {:ok, state} for the Pigeon.Dispatcher state, or {:stop, atom} if started with invalid configuration options.","ref":"Pigeon.Adapter.html#c:init/1","title":"Pigeon.Adapter.init/1","type":"callback"},{"doc":"Dispatcher worker for push notifications. If your push workers are relatively static, it is encouraged to follow the adapter guides. For other use cases, such as supporting dynamic configurations, dispatchers can be started and stopped as needed. Using Dynamic Dispatchers # FCM as an example, but use the relevant options for your push type. opts = [ adapter : Pigeon.FCM , project_id : &quot;example-project-123&quot; , service_account_json : File . read! ( &quot;service-account.json&quot; ) ] { :ok , pid } = Pigeon.Dispatcher . start_link ( opts ) notification = Pigeon.FCM.Notification . new ( { :token , &quot;regid&quot; } ) Pigeon . push ( pid , notification ) Loading Configurations from a Database defmodule YourApp.Application do @moduledoc false use Application @doc false def start ( _type , _args ) do children = [ YourApp.Repo , { Registry , keys : :unique , name : Registry.YourApp } ] ++ push_workers ( ) opts = [ strategy : :one_for_one , name : YourApp.Supervisor ] Supervisor . start_link ( children , opts ) end defp push_workers do YourApp.Repo.PushApplication |&gt; YourApp.Repo . all ( ) |&gt; Enum . map ( &amp; push_spec / 1 ) end defp push_spec ( %{ type : &quot;apns&quot; } = config ) { Pigeon.Dispatcher , [ adapter : Pigeon.APNS , key : config . key , key_identifier : config . key_identifier , team_id : config . team_id , mode : config . mode , name : { :via , Registry , { Registry.YourApp , config . name } } ] } end defp push_spec ( %{ type : &quot;fcm&quot; } = config ) do { Pigeon.Dispatcher , [ adapter : Pigeon.FCM , name : { :via , Registry , { Registry.YourApp , config . name } } , project_id : config . project_id , service_account_json : config . service_account_json ] } end end Once running, you can send to any of these workers by name. Pigeon . push ( { :via , Registry , { Registry.YourApp , &quot;app1&quot; } } , notification )","ref":"Pigeon.Dispatcher.html","title":"Pigeon.Dispatcher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Pigeon.Dispatcher.html#child_spec/1","title":"Pigeon.Dispatcher.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"Pigeon.Dispatcher.html#init/1","title":"Pigeon.Dispatcher.init/1","type":"function"},{"doc":"","ref":"Pigeon.Dispatcher.html#start_link/1","title":"Pigeon.Dispatcher.start_link/1","type":"function"},{"doc":"Internal push notification metadata.","ref":"Pigeon.Metadata.html","title":"Pigeon.Metadata","type":"module"},{"doc":"","ref":"Pigeon.Metadata.html#t:t/0","title":"Pigeon.Metadata.t/0","type":"type"},{"doc":"Sandbox adapter for any kind of push notification. If the push notification has response: nil , it will be marked with response: :success . Otherwise it will return the push notification exactly as given.","ref":"Pigeon.Sandbox.html","title":"Pigeon.Sandbox","type":"module"},{"doc":"Pigeon.Adapter for ADM (Amazon Android) push notifications. Getting Started Create an ADM dispatcher. # lib/adm.ex defmodule YourApp.ADM do use Pigeon.Dispatcher , otp_app : :your_app end (Optional) Add configuration to your config.exs . # config.exs config :your_app , YourApp.ADM , adapter : Pigeon.ADM , client_id : &quot;your_oauth2_client_id_here&quot; , client_secret : &quot;your_oauth2_client_secret_here&quot; Start your dispatcher on application boot. defmodule YourApp.Application do @moduledoc false use Application @doc false def start ( _type , _args ) do children = [ YourApp.ADM ] opts = [ strategy : :one_for_one , name : YourApp.Supervisor ] Supervisor . start_link ( children , opts ) end end If you skipped step two, include your configuration. defmodule YourApp.Application do @moduledoc false use Application @doc false def start ( _type , _args ) do children = [ { YourApp.ADM , adm_opts ( ) } ] opts = [ strategy : :one_for_one , name : YourApp.Supervisor ] Supervisor . start_link ( children , opts ) end defp adm_opts do [ adapter : Pigeon.ADM , client_id : &quot;client_id&quot; , client_secret : &quot;secret&quot; ] end end Create a notification. msg = %{ &quot;body&quot; =&gt; &quot;your message&quot; } n = Pigeon.ADM.Notification . new ( &quot;your device registration ID&quot; , msg ) Send the notification. YourApp.ADM . push ( n ) Handling Push Responses Pass an optional anonymous function as your second parameter. data = %{ message : &quot;your message&quot; } n = Pigeon.ADM.Notification . new ( &quot;device registration ID&quot; , data ) YourApp.ADM . push ( n , on_response : fn ( x ) -&gt; IO . inspect ( x ) end ) Responses return a notification with an updated :response key. You could handle responses like so: on_response_handler = fn ( x ) -&gt; case x . response do :success -&gt; # Push successful :ok :update -&gt; new_reg_id = x . updated_registration_id # Update the registration ID in the database :invalid_registration_id -&gt; # Remove the bad ID from the database :unregistered -&gt; # Remove the bad ID from the database error -&gt; # Handle other errors end end data = %{ message : &quot;your message&quot; } n = Pigeon.ADM.Notification . new ( &quot;your registration id&quot; , data ) Pigeon.ADM . push ( n , on_response : on_response_handler ) Error Responses Taken from Amazon Device Messaging docs Reason Description :invalid_registration_id Invalid Registration Token :invalid_data Bad format JSON data :invalid_consolidation_key Invalid Consolidation Key :invalid_expiration Invalid expiresAfter value :invalid_checksum Invalid md5 value :invalid_type Invalid Type header :unregistered App instance no longer available :access_token_expired Expired OAuth access token :message_too_large Data size exceeds 6 KB :max_rate_exceeded See Retry-After response header :unknown_error Unknown Error","ref":"Pigeon.ADM.html","title":"Pigeon.ADM","type":"module"},{"doc":"Defines Amazon ADM notification struct and convenience constructor functions.","ref":"Pigeon.ADM.Notification.html","title":"Pigeon.ADM.Notification","type":"module"},{"doc":"Creates ADM.Notification struct with device registration ID and optional data payload. Examples iex&gt; Pigeon.ADM.Notification . new ( &quot;reg ID&quot; ) % Pigeon.ADM.Notification { consolidation_key : nil , md5 : &quot;1B2M2Y8AsgTpgAmY7PhCfg==&quot; , payload : %{ &quot;data&quot; =&gt; %{ } } , registration_id : &quot;reg ID&quot; , updated_registration_id : nil } iex&gt; Pigeon.ADM.Notification . new ( &quot;reg ID&quot; , %{ &quot;message&quot; =&gt; &quot;your message&quot; } ) % Pigeon.ADM.Notification { consolidation_key : nil , md5 : &quot;qzF+HgArKZjJrpfcTbiFxg==&quot; , payload : %{ &quot;data&quot; =&gt; %{ &quot;message&quot; =&gt; &quot;your message&quot; } } , registration_id : &quot;reg ID&quot; , updated_registration_id : nil } iex&gt; Pigeon.ADM.Notification . new ( &quot;reg ID&quot; , &quot;not a map&quot; ) % Pigeon.ADM.Notification { consolidation_key : nil , md5 : &quot;1B2M2Y8AsgTpgAmY7PhCfg==&quot; , payload : %{ &quot;data&quot; =&gt; %{ } } , registration_id : &quot;reg ID&quot; , updated_registration_id : nil }","ref":"Pigeon.ADM.Notification.html#new/2","title":"Pigeon.ADM.Notification.new/2","type":"function"},{"doc":"Updates &quot;data&quot; key on push payload and calculates md5 hash. Examples iex&gt; n = % Pigeon.ADM.Notification { } iex&gt; Pigeon.ADM.Notification . put_data ( n , %{ &quot;message&quot; =&gt; &quot;your message&quot; } ) % Pigeon.ADM.Notification { consolidation_key : nil , md5 : &quot;qzF+HgArKZjJrpfcTbiFxg==&quot; , payload : %{ &quot;data&quot; =&gt; %{ &quot;message&quot; =&gt; &quot;your message&quot; } } , registration_id : nil , updated_registration_id : nil }","ref":"Pigeon.ADM.Notification.html#put_data/2","title":"Pigeon.ADM.Notification.put_data/2","type":"function"},{"doc":"ADM error responses","ref":"Pigeon.ADM.Notification.html#t:error_response/0","title":"Pigeon.ADM.Notification.error_response/0","type":"type"},{"doc":"ADM push response nil - Push has not been sent yet :success - Push was successfully sent error_response/0 - Push attempted but server responded with error :timeout - Internal error. Push did not reach ADM servers","ref":"Pigeon.ADM.Notification.html#t:response/0","title":"Pigeon.ADM.Notification.response/0","type":"type"},{"doc":"ADM notification Examples % Pigeon.ADM.Notification { consolidation_key : nil , expires_after : 604_800 , md5 : &quot;qzF+HgArKZjJrpfcTbiFxg==&quot; , payload : %{ &quot;data&quot; =&gt; %{ &quot;message&quot; =&gt; &quot;your message&quot; } } , registration_id : &quot;reg ID&quot; , response : nil , # Set on push response updated_registration_id : nil }","ref":"Pigeon.ADM.Notification.html#t:t/0","title":"Pigeon.ADM.Notification.t/0","type":"type"},{"doc":"Pigeon.Adapter for Apple Push Notification Service (APNS) push notifications. Getting Started Create an APNS dispatcher. # lib/apns.ex defmodule YourApp.APNS do use Pigeon.Dispatcher , otp_app : :your_app end (Optional) Add configuration to your config.exs . # config.exs config :your_app , YourApp.APNS , adapter : Pigeon.APNS , cert : File . read! ( &quot;cert.pem&quot; ) , key : File . read! ( &quot;key_unencrypted.pem&quot; ) , mode : :dev Or use token based authentication: config :your_app , YourApp.APNS , adapter : Pigeon.APNS , key : File . read! ( &quot;AuthKey.p8&quot; ) , key_identifier : &quot;ABC1234567&quot; , mode : :dev , team_id : &quot;DEF8901234&quot; Start your dispatcher on application boot. defmodule YourApp.Application do @moduledoc false use Application @doc false def start ( _type , _args ) do children = [ YourApp.APNS ] opts = [ strategy : :one_for_one , name : YourApp.Supervisor ] Supervisor . start_link ( children , opts ) end end If you skipped step two, include your configuration. defmodule YourApp.Application do @moduledoc false use Application @doc false def start ( _type , _args ) do children = [ { YourApp.APNS , apns_opts ( ) } ] opts = [ strategy : :one_for_one , name : YourApp.Supervisor ] Supervisor . start_link ( children , opts ) end defp apns_opts do [ adapter : Pigeon.APNS , cert : File . read! ( &quot;cert.pem&quot; ) , key : File . read! ( &quot;key_unencrypted.pem&quot; ) , mode : :dev ] end end Create a notification. Note: Your push topic is generally the app's bundle identifier. n = Pigeon.APNS.Notification . new ( &quot;your message&quot; , &quot;your device token&quot; , &quot;your push topic&quot; ) Send the packet. Pushes are synchronous and return the notification with an updated :response key. YourApp.APNS . push ( n ) Configuration Options Certificate Authentication :cert - Push certificate. Must be the full-text string of the file contents. :key - Push private key. Must be the full-text string of the file contents. Token Authentication :key - JWT private key. Must be the full-text string of the file contents. :key_identifier - A 10-character key identifier (kid) key, obtained from your developer account. :team_id - Your 10-character Team ID, obtained from your developer account. Shared Options :mode - If set to :dev or :prod , will set the appropriate :uri . :ping_period - Interval between server pings. Necessary to keep long running APNS connections alive. Defaults to 10 minutes. :port - Push server port. Can be any value, but APNS only accepts 443 and 2197 . :uri - Push server uri. If set, overrides uri defined by :mode . Useful for test environments. Generating Your Certificate and Key .pem In Keychain Access, right-click your push certificate and select &quot;Export...&quot; Export the certificate as cert.p12 Click the dropdown arrow next to the certificate, right-click the private key and select &quot;Export...&quot; Export the private key as key.p12 From a shell, convert the certificate. openssl pkcs12 - clcerts - nokeys - out cert . pem - in cert . p12 Convert the key. Be sure to set a PEM pass phrase here. The pass phrase must be 4 or more characters in length or this will not work. You will need that pass phrase added here in order to remove it in the next step. openssl pkcs12 - nocerts - out key . pem - in key . p12 Remove the PEM pass phrase from the key. openssl rsa - in key . pem - out key_unencrypted . pem cert.pem and key_unencrypted.pem can now be used in your configuration.","ref":"Pigeon.APNS.html","title":"Pigeon.APNS","type":"module"},{"doc":"Defines APNS notification struct and constructor functions.","ref":"Pigeon.APNS.Notification.html","title":"Pigeon.APNS.Notification","type":"module"},{"doc":"Returns an APNS.Notification struct with given message, device token, and topic (optional). Push payload is constructed in the form of %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; msg}} Examples iex&gt; Pigeon.APNS.Notification . new ( &quot;push message&quot; , &quot;device token&quot; ) % Pigeon.APNS.Notification { __meta__ : % Pigeon.Metadata { } , device_token : &quot;device token&quot; , expiration : nil , priority : nil , push_type : &quot;alert&quot; , id : nil , payload : %{ &quot;aps&quot; =&gt; %{ &quot;alert&quot; =&gt; &quot;push message&quot; } } , topic : nil }","ref":"Pigeon.APNS.Notification.html#new/3","title":"Pigeon.APNS.Notification.new/3","type":"function"},{"doc":"Returns an APNS.Notification struct with given message, device token, topic, and message ID. Push payload is constructed in the form of %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; msg}} Examples iex&gt; Pigeon.APNS.Notification . new ( &quot;push message&quot; , &quot;device token&quot; , &quot;topic&quot; , &quot;id_1234&quot; ) % Pigeon.APNS.Notification { collapse_id : nil , device_token : &quot;device token&quot; , expiration : nil , priority : nil , push_type : &quot;alert&quot; , id : &quot;id_1234&quot; , payload : %{ &quot;aps&quot; =&gt; %{ &quot;alert&quot; =&gt; &quot;push message&quot; } } , topic : &quot;topic&quot; }","ref":"Pigeon.APNS.Notification.html#new/4","title":"Pigeon.APNS.Notification.new/4","type":"function"},{"doc":"Updates &quot;alert&quot; key in push payload. This is the alert message displayed on the device. Examples iex&gt; Pigeon.APNS.Notification . put_alert ( % Pigeon.APNS.Notification { } , &quot;push message&quot; ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;alert&quot; =&gt; &quot;push message&quot; } } }","ref":"Pigeon.APNS.Notification.html#put_alert/2","title":"Pigeon.APNS.Notification.put_alert/2","type":"function"},{"doc":"Updates &quot;badge&quot; key in push payload. This is the badge number displayed on the application. Examples iex&gt; Pigeon.APNS.Notification . put_badge ( % Pigeon.APNS.Notification { } , 5 ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;badge&quot; =&gt; 5 } } }","ref":"Pigeon.APNS.Notification.html#put_badge/2","title":"Pigeon.APNS.Notification.put_badge/2","type":"function"},{"doc":"Updates &quot;category&quot; key in push payload. Examples iex&gt; Pigeon.APNS.Notification . put_category ( % Pigeon.APNS.Notification { } , &quot;category&quot; ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;category&quot; =&gt; &quot;category&quot; } } }","ref":"Pigeon.APNS.Notification.html#put_category/2","title":"Pigeon.APNS.Notification.put_category/2","type":"function"},{"doc":"Sets &quot;content-available&quot; flag in push payload. Used for silent notifications. When set, ensure alert , badge , and sound keys are not configured. Examples iex&gt; Pigeon.APNS.Notification . put_content_available ( % Pigeon.APNS.Notification { } ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;content-available&quot; =&gt; 1 } } }","ref":"Pigeon.APNS.Notification.html#put_content_available/1","title":"Pigeon.APNS.Notification.put_content_available/1","type":"function"},{"doc":"Puts custom data in push payload. Examples iex&gt; n = Pigeon.APNS.Notification . new ( &quot;test message&quot; , &quot;device token&quot; ) iex&gt; Pigeon.APNS.Notification . put_custom ( n , %{ &quot;custom-key&quot; =&gt; 1234 } ) % Pigeon.APNS.Notification { device_token : &quot;device token&quot; , payload : %{ &quot;aps&quot; =&gt; %{ &quot;alert&quot; =&gt; &quot;test message&quot; } , &quot;custom-key&quot; =&gt; 1234 } }","ref":"Pigeon.APNS.Notification.html#put_custom/2","title":"Pigeon.APNS.Notification.put_custom/2","type":"function"},{"doc":"Updates &quot;interruption-level&quot; key in push payload. Used for managing time sensitive notifications Examples iex&gt; Pigeon.APNS.Notification . put_interruption_level ( % Pigeon.APNS.Notification { } , &quot;time-sensitive&quot; ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;interruption-level&quot; =&gt; &quot;time-sensitive&quot; } } }","ref":"Pigeon.APNS.Notification.html#put_interruption_level/2","title":"Pigeon.APNS.Notification.put_interruption_level/2","type":"function"},{"doc":"Sets &quot;mutable-content&quot; flag in push payload. Used for notification service extensions (such as displaying custom media). Examples iex&gt; Pigeon.APNS.Notification . put_mutable_content ( % Pigeon.APNS.Notification { } ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;mutable-content&quot; =&gt; 1 } } }","ref":"Pigeon.APNS.Notification.html#put_mutable_content/1","title":"Pigeon.APNS.Notification.put_mutable_content/1","type":"function"},{"doc":"Updates &quot;sound&quot; key in push payload. Used for custom notification sounds. Value should be the name of the custom sound file in the application's binary. Examples iex&gt; Pigeon.APNS.Notification . put_sound ( % Pigeon.APNS.Notification { } , &quot;custom.aiff&quot; ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;sound&quot; =&gt; &quot;custom.aiff&quot; } } } iex&gt; Pigeon.APNS.Notification . put_sound ( % Pigeon.APNS.Notification { } , %{ ...&gt; &quot;critical&quot; =&gt; 1 , ...&gt; &quot;sound&quot; =&gt; &quot;default&quot; , ...&gt; &quot;volume&quot; =&gt; 1.0 ...&gt; } ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;sound&quot; =&gt; %{ &quot;critical&quot; =&gt; 1 , &quot;sound&quot; =&gt; &quot;default&quot; , &quot;volume&quot; =&gt; 1.0 } } } }","ref":"Pigeon.APNS.Notification.html#put_sound/2","title":"Pigeon.APNS.Notification.put_sound/2","type":"function"},{"doc":"Updates &quot;target-content-id&quot; key in push payload. Used for bringing a specific window forward. Examples iex&gt; Pigeon.APNS.Notification . put_target_content_id ( % Pigeon.APNS.Notification { } , &quot;example&quot; ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;target-content-id&quot; =&gt; &quot;example&quot; } } }","ref":"Pigeon.APNS.Notification.html#put_target_content_id/2","title":"Pigeon.APNS.Notification.put_target_content_id/2","type":"function"},{"doc":"Updates &quot;thread-id&quot; key in push payload. Used for grouping related notifications. Examples iex&gt; Pigeon.APNS.Notification . put_thread_id ( % Pigeon.APNS.Notification { } , &quot;example&quot; ) % Pigeon.APNS.Notification { payload : %{ &quot;aps&quot; =&gt; %{ &quot;thread-id&quot; =&gt; &quot;example&quot; } } }","ref":"Pigeon.APNS.Notification.html#put_thread_id/2","title":"Pigeon.APNS.Notification.put_thread_id/2","type":"function"},{"doc":"","ref":"Pigeon.APNS.Notification.html#t:error_response/0","title":"Pigeon.APNS.Notification.error_response/0","type":"type"},{"doc":"APNS push response nil - Push has not been sent yet. :success - Push was successfully sent. t:Pigeon.APNS.Error.error_response/0 - Push attempted but server responded with error. :timeout - Internal error. Push did not reach APNS servers.","ref":"Pigeon.APNS.Notification.html#t:response/0","title":"Pigeon.APNS.Notification.response/0","type":"type"},{"doc":"APNS notification Examples % Pigeon.APNS.Notification { __meta__ : % Pigeon.Metadata { on_response : nil } , collapse_id : nil , device_token : &quot;device token&quot; , expiration : nil , id : nil , # Set on push response if nil payload : %{ &quot;aps&quot; =&gt; %{ &quot;alert&quot; =&gt; &quot;push message&quot; } } , priority : nil , push_type : &quot;alert&quot; , response : nil , # Set on push response topic : &quot;com.example.YourApp&quot; }","ref":"Pigeon.APNS.Notification.html#t:t/0","title":"Pigeon.APNS.Notification.t/0","type":"type"},{"doc":"Pigeon.Adapter for Firebase Cloud Messaging (FCM) push notifications. Getting Started Create a FCM dispatcher. # lib/fcm.ex defmodule YourApp.FCM do use Pigeon.Dispatcher , otp_app : :your_app end (Optional) Add configuration to your config.exs . # config.exs config :your_app , YourApp.FCM , adapter : Pigeon.FCM , project_id : &quot;example-project-123&quot; , service_account_json : File . read! ( &quot;service-account.json&quot; ) Start your dispatcher on application boot. defmodule YourApp.Application do @moduledoc false use Application @doc false def start ( _type , _args ) do children = [ YourApp.FCM ] opts = [ strategy : :one_for_one , name : YourApp.Supervisor ] Supervisor . start_link ( children , opts ) end end If you skipped step two, include your configuration. defmodule YourApp.Application do @moduledoc false use Application @doc false def start ( _type , _args ) do children = [ { YourApp.FCM , fcm_opts ( ) } ] opts = [ strategy : :one_for_one , name : YourApp.Supervisor ] Supervisor . start_link ( children , opts ) end defp fcm_opts do [ adapter : Pigeon.FCM , project_id : &quot;example-project-123&quot; , service_account_json : File . read! ( &quot;service-account.json&quot; ) ] end end Create a notification. n = Pigeon.FCM.Notification . new ( { :token , &quot;reg ID&quot; } , %{ &quot;body&quot; =&gt; &quot;test message&quot; } ) Send the notification. On successful response, :name will be set to the name returned from the FCM API and :response will be :success . If there was an error, :error will contain a JSON map of the response and :response will be an atomized version of the error type. YourApp.FCM . push ( n )","ref":"Pigeon.FCM.html","title":"Pigeon.FCM","type":"module"},{"doc":"Defines FCM notification struct and convenience constructor functions.","ref":"Pigeon.FCM.Notification.html","title":"Pigeon.FCM.Notification","type":"module"},{"doc":"Creates FCM.Notification struct with given target and optional notification and data payloads. Examples iex&gt; Pigeon.FCM.Notification . new ( { :token , &quot;reg ID&quot; } ) % Pigeon.FCM.Notification { data : nil , notification : nil , target : { :token , &quot;reg ID&quot; } } iex&gt; Pigeon.FCM.Notification . new ( { :topic , &quot;example&quot; } ) % Pigeon.FCM.Notification { data : nil , notification : nil , target : { :topic , &quot;example&quot; } } iex&gt; Pigeon.FCM.Notification . new ( { :token , &quot;reg ID&quot; } , %{ &quot;body&quot; =&gt; &quot;test message&quot; } ) % Pigeon.FCM.Notification { data : nil , notification : %{ &quot;body&quot; =&gt; &quot;test message&quot; } , target : { :token , &quot;reg ID&quot; } } iex&gt; Pigeon.FCM.Notification . new ( { :token , &quot;reg ID&quot; } , %{ &quot;body&quot; =&gt; &quot;test message&quot; } , ...&gt; %{ &quot;key&quot; =&gt; &quot;value&quot; } ) % Pigeon.FCM.Notification { data : %{ &quot;key&quot; =&gt; &quot;value&quot; } , notification : %{ &quot;body&quot; =&gt; &quot;test message&quot; } , target : { :token , &quot;reg ID&quot; } }","ref":"Pigeon.FCM.Notification.html#new/3","title":"Pigeon.FCM.Notification.new/3","type":"function"},{"doc":"","ref":"Pigeon.FCM.Notification.html#t:error_response/0","title":"Pigeon.FCM.Notification.error_response/0","type":"type"},{"doc":"","ref":"Pigeon.FCM.Notification.html#t:t/0","title":"Pigeon.FCM.Notification.t/0","type":"type"},{"doc":"FCM notification target. Must be one of the following: {:token, &quot;string&quot;} - Registration token to send a message to. {:topic, &quot;string&quot;} - Topic name to send a message to, e.g. &quot;weather&quot;. Note: &quot;/topics/&quot; prefix should not be provided. {:condition, &quot;string&quot;} - Condition to send a message to, e.g. &quot;'foo' in topics &amp;&amp; 'bar' in topics&quot;.","ref":"Pigeon.FCM.Notification.html#t:target/0","title":"Pigeon.FCM.Notification.target/0","type":"type"},{"doc":"Pigeon.Adapter for Legacy Firebase Cloud Messaging (FCM) push notifications. Getting Started Create a LegacyFCM dispatcher. # lib/legacy_fcm.ex defmodule YourApp.LegacyFCM do use Pigeon.Dispatcher , otp_app : :your_app end (Optional) Add configuration to your config.exs . # config.exs config :your_app , YourApp.LegacyFCM , adapter : Pigeon.LegacyFCM , key : &quot;your_fcm_key_here&quot; Start your dispatcher on application boot. defmodule YourApp.Application do @moduledoc false use Application @doc false def start ( _type , _args ) do children = [ YourApp.LegacyFCM ] opts = [ strategy : :one_for_one , name : YourApp.Supervisor ] Supervisor . start_link ( children , opts ) end end If you skipped step two, include your configuration. defmodule YourApp.Application do @moduledoc false use Application @doc false def start ( _type , _args ) do children = [ { YourApp.ADM , legacy_fcm_opts ( ) } ] opts = [ strategy : :one_for_one , name : YourApp.Supervisor ] Supervisor . start_link ( children , opts ) end defp legacy_fcm_opts do [ adapter : Pigeon.LegacyFCM , key : &quot;your_fcm_key_here&quot; ] end end Create a notification. msg = %{ &quot;body&quot; =&gt; &quot;your message&quot; } n = Pigeon.LegacyFCM.Notification . new ( &quot;your device registration ID&quot; , msg ) Send the notification. Pushes are synchronous and return the notification with updated :status and :response keys. If :status is success, :response will contain a keyword list of individual registration ID responses. YourApp.LegacyFCM . push ( n ) Sending to Multiple Registration IDs Pass in a list of registration IDs, as many as you want. msg = %{ &quot;body&quot; =&gt; &quot;your message&quot; } n = Pigeon.FCM.Notification . new ( [ &quot;first ID&quot; , &quot;second ID&quot; ] , msg ) Notification Struct % Pigeon.LegacyFCM.Notification { collapse_key : nil | String . t ( ) , dry_run : boolean , message_id : nil | String . t ( ) , payload : %{ ... } , priority : :normal | :high , registration_id : String . t ( ) | [ String . t ( ) , ... ] , response : [ ] | [ { atom , String . t ( ) } , ... ] , | atom , restricted_package_name : nil | String . t ( ) , status : atom | nil , time_to_live : non_neg_integer } Notifications with Custom Data FCM accepts both notification and data keys in its JSON payload. Set them like so: notification = %{ &quot;body&quot; =&gt; &quot;your message&quot; } data = %{ &quot;key&quot; =&gt; &quot;value&quot; } Pigeon.LegacyFCM.Notification . new ( &quot;registration ID&quot; , notification , data ) or Pigeon.LegacyFCM.Notification . new ( &quot;registration ID&quot; ) |&gt; put_notification ( %{ &quot;body&quot; =&gt; &quot;your message&quot; } ) |&gt; put_data ( %{ &quot;key&quot; =&gt; &quot;value&quot; } ) Handling Push Responses Pass an optional anonymous function as your second parameter. data = %{ message : &quot;your message&quot; } n = Pigeon.FCM.Notification . new ( data , &quot;device registration ID&quot; ) Pigeon.FCM . push ( n , fn ( x ) -&gt; IO . inspect ( x ) end ) { :ok , % Pigeon.FCM.Notification { ... } } Responses return the notification with an updated response. on_response = fn ( n ) -&gt; case n . status do :success -&gt; bad_regids = FCM.Notification . remove? ( n ) to_retry = FCM.Notification . retry? ( n ) # Handle updated regids, remove bad ones, etc :unauthorized -&gt; # Bad FCM key error -&gt; # Some other error end end data = %{ message : &quot;your message&quot; } n = Pigeon.FCM.Notification . new ( &quot;your device token&quot; , data ) Pigeon.FCM . push ( n , on_response : on_response ) Error Responses Slightly modified from FCM Server Reference Reason Description :missing_registration Missing Registration Token :invalid_registration Invalid Registration Token :not_registered Unregistered Device :invalid_package_name Invalid Package Name :authentication_error Authentication Error :mismatch_sender_id Mismatched Sender :invalid_json Invalid JSON :message_too_big Message Too Big :invalid_data_key Invalid Data Key :invalid_ttl Invalid Time to Live :unavailable Timeout :internal_server_error Internal Server Error :device_message_rate_exceeded Message Rate Exceeded :topics_message_rate_exceeded Topics Message Rate Exceeded :unknown_error Unknown Error","ref":"Pigeon.LegacyFCM.html","title":"Pigeon.LegacyFCM","type":"module"},{"doc":"Defines Pigeon.LegacyFCM.Notification struct and convenience constructor functions.","ref":"Pigeon.LegacyFCM.Notification.html","title":"Pigeon.LegacyFCM.Notification","type":"module"},{"doc":"Creates LegacyFCM.Notification struct with device registration IDs and optional notification and data payloads. Examples iex&gt; Pigeon.LegacyFCM.Notification . new ( &quot;reg ID&quot; ) % Pigeon.LegacyFCM.Notification { payload : %{ } , registration_id : &quot;reg ID&quot; , priority : :normal } iex&gt; Pigeon.LegacyFCM.Notification . new ( &quot;reg ID&quot; , %{ &quot;body&quot; =&gt; &quot;test message&quot; } ) % Pigeon.LegacyFCM.Notification { payload : %{ &quot;notification&quot; =&gt; %{ &quot;body&quot; =&gt; &quot;test message&quot; } } , registration_id : &quot;reg ID&quot; , priority : :normal } iex&gt; Pigeon.LegacyFCM.Notification . new ( &quot;reg ID&quot; , %{ &quot;body&quot; =&gt; &quot;test message&quot; } , ...&gt; %{ &quot;key&quot; =&gt; &quot;value&quot; } ) % Pigeon.LegacyFCM.Notification { payload : %{ &quot;data&quot; =&gt; %{ &quot;key&quot; =&gt; &quot;value&quot; } , &quot;notification&quot; =&gt; %{ &quot;body&quot; =&gt; &quot;test message&quot; } } , registration_id : &quot;reg ID&quot; , priority : :normal } iex&gt; regids = Enum . map ( 0 .. 1_499 , fn ( _x ) -&gt; &quot;reg ID&quot; end ) iex&gt; [ n1 | [ n2 ] ] = Pigeon.LegacyFCM.Notification . new ( regids , ...&gt; %{ &quot;body&quot; =&gt; &quot;test message&quot; } , %{ &quot;key&quot; =&gt; &quot;value&quot; } ) iex&gt; Enum . count ( n1 . registration_id ) 1000 iex&gt; Enum . count ( n2 . registration_id ) 500","ref":"Pigeon.LegacyFCM.Notification.html#new/3","title":"Pigeon.LegacyFCM.Notification.new/3","type":"function"},{"doc":"Updates &quot;collapse_key&quot; key. Examples iex&gt; put_collapse_key ( % Pigeon.LegacyFCM.Notification { } , &quot;Updates available&quot; ) % Pigeon.LegacyFCM.Notification { collapse_key : &quot;Updates available&quot; }","ref":"Pigeon.LegacyFCM.Notification.html#put_collapse_key/2","title":"Pigeon.LegacyFCM.Notification.put_collapse_key/2","type":"function"},{"doc":"Updates &quot;condition&quot; key. Supported condition: Topic, formatted as &quot;'yourTopic' in topics&quot;. This value is case-insensitive. Supported operators: &amp;&amp;, ||. Maximum two operators per topic message supported. Examples iex&gt; put_condition ( % Pigeon.LegacyFCM.Notification { } , &quot;&#39;test&#39; in topics&quot; ) % Pigeon.LegacyFCM.Notification { condition : &quot;&#39;test&#39; in topics&quot; }","ref":"Pigeon.LegacyFCM.Notification.html#put_condition/2","title":"Pigeon.LegacyFCM.Notification.put_condition/2","type":"function"},{"doc":"Updates &quot;content_available&quot; key. On iOS, use this field to represent content-available in the APNs payload. When a notification or message is sent and this is set to true, an inactive client app is awoken, and the message is sent through APNs as a silent notification and not through the FCM connection server. Note that silent notifications in APNs are not guaranteed to be delivered, and can depend on factors such as the user turning on Low Power Mode, force quitting the app, etc. On Android, data messages wake the app by default. On Chrome, currently not supported. Examples iex&gt; put_content_available ( % Pigeon.LegacyFCM.Notification { } , true ) % Pigeon.LegacyFCM.Notification { content_available : true }","ref":"Pigeon.LegacyFCM.Notification.html#put_content_available/2","title":"Pigeon.LegacyFCM.Notification.put_content_available/2","type":"function"},{"doc":"Updates &quot;data&quot; key in push payload. This parameter specifies the custom key-value pairs of the message's payload. For example, with data:{&quot;score&quot;:&quot;3x1&quot;}: On iOS, if the message is sent via APNs, it represents the custom data fields. If it is sent via FCM connection server, it would be represented as key value dictionary in AppDelegate application:didReceiveRemoteNotification:. On Android, this would result in an intent extra named score with the string value 3x1. The key should not be a reserved word (&quot;from&quot; or any word starting with &quot;google&quot; or &quot;gcm&quot;). Do not use any of the words defined in this table (such as collapse_key). Values in string types are recommended. You have to convert values in objects or other non-string data types (e.g., integers or booleans) to string. Examples iex&gt; put_data ( % Pigeon.LegacyFCM.Notification { } , %{ &quot;key&quot; =&gt; 1234 } ) % Pigeon.LegacyFCM.Notification { payload : %{ &quot;data&quot; =&gt; %{ &quot;key&quot; =&gt; 1234 } } , registration_id : nil }","ref":"Pigeon.LegacyFCM.Notification.html#put_data/2","title":"Pigeon.LegacyFCM.Notification.put_data/2","type":"function"},{"doc":"Sets &quot;dry_run&quot; key to true. This parameter, when set to true, allows developers to test a request without actually sending a message. The default value is false. Examples iex&gt; put_dry_run ( % Pigeon.LegacyFCM.Notification { } ) % Pigeon.LegacyFCM.Notification { dry_run : true }","ref":"Pigeon.LegacyFCM.Notification.html#put_dry_run/1","title":"Pigeon.LegacyFCM.Notification.put_dry_run/1","type":"function"},{"doc":"Updates &quot;mutable_content&quot; key. Currently for iOS 10+ devices only. On iOS, use this field to represent mutable-content in the APNs payload. When a notification is sent and this is set to true, the content of the notification can be modified before it is displayed, using a Notification Service app extension. This parameter will be ignored for Android and web. Examples iex&gt; put_mutable_content ( % Pigeon.LegacyFCM.Notification { } , true ) % Pigeon.LegacyFCM.Notification { mutable_content : true }","ref":"Pigeon.LegacyFCM.Notification.html#put_mutable_content/2","title":"Pigeon.LegacyFCM.Notification.put_mutable_content/2","type":"function"},{"doc":"Updates &quot;notification&quot; key in push payload. This parameter specifies the predefined, user-visible key-value pairs of the notification payload. See Notification payload support for detail. For more information about notification message and data message options, see Message types . If a notification payload is provided, or the content_available option is set to true for a message to an iOS device, the message is sent through APNs, otherwise it is sent through the FCM connection server. Examples iex&gt; put_notification ( % Pigeon.LegacyFCM.Notification { } , ...&gt; %{ &quot;body&quot; =&gt; &quot;message&quot; } ) % Pigeon.LegacyFCM.Notification { payload : %{ &quot;notification&quot; =&gt; %{ &quot;body&quot; =&gt; &quot;message&quot; } } , registration_id : nil }","ref":"Pigeon.LegacyFCM.Notification.html#put_notification/2","title":"Pigeon.LegacyFCM.Notification.put_notification/2","type":"function"},{"doc":"Updates &quot;priority&quot; key. Sets the priority of the message. Valid values are &quot;normal&quot; and &quot;high.&quot; On iOS, these correspond to APNs priorities 5 and 10. By default, notification messages are sent with high priority, and data messages are sent with normal priority. Normal priority optimizes the client app's battery consumption and should be used unless immediate delivery is required. For messages with normal priority, the app may receive the message with unspecified delay. When a message is sent with high priority, it is sent immediately, and the app can display a notification. Examples iex&gt; put_priority ( % Pigeon.LegacyFCM.Notification { } , :normal ) % Pigeon.LegacyFCM.Notification { priority : :normal } iex&gt; put_priority ( % Pigeon.LegacyFCM.Notification { } , :high ) % Pigeon.LegacyFCM.Notification { priority : :high } iex&gt; put_priority ( % Pigeon.LegacyFCM.Notification { priority : :normal } , :bad ) % Pigeon.LegacyFCM.Notification { priority : :normal }","ref":"Pigeon.LegacyFCM.Notification.html#put_priority/2","title":"Pigeon.LegacyFCM.Notification.put_priority/2","type":"function"},{"doc":"Updates &quot;restricted_package_name&quot; key. This parameter specifies the package name of the application where the registration tokens must match in order to receive the message. (Only affects android) Examples iex&gt; put_restricted_package_name ( % Pigeon.LegacyFCM.Notification { } , &quot;com.example.app&quot; ) % Pigeon.LegacyFCM.Notification { restricted_package_name : &quot;com.example.app&quot; }","ref":"Pigeon.LegacyFCM.Notification.html#put_restricted_package_name/2","title":"Pigeon.LegacyFCM.Notification.put_restricted_package_name/2","type":"function"},{"doc":"Updates &quot;time_to_live&quot; key. This parameter specifies how long (in seconds) the message should be kept in FCM storage if the device is offline. The maximum time to live supported is 4 weeks, and the default value is 4 weeks. For more information, see Setting the lifespan of a message . Examples iex&gt; put_time_to_live ( % Pigeon.LegacyFCM.Notification { } , 60 * 60 * 24 ) % Pigeon.LegacyFCM.Notification { time_to_live : 86_400 }","ref":"Pigeon.LegacyFCM.Notification.html#put_time_to_live/2","title":"Pigeon.LegacyFCM.Notification.put_time_to_live/2","type":"function"},{"doc":"Returns a list of registration IDs that should be removed Examples iex&gt; n = % Pigeon.LegacyFCM.Notification { response : [ ...&gt; { :success , &quot;regid1&quot; } , { :invalid_registration , &quot;regid2&quot; } , ...&gt; { :success , &quot;regid3&quot; } , { :update , { &quot;regid4&quot; , &quot;new_regid4&quot; } } , ...&gt; { :not_registered , &quot;regid5&quot; } , { :unavailable , &quot;regid6&quot; } ] } iex&gt; remove? ( n ) [ &quot;regid2&quot; , &quot;regid5&quot; ]","ref":"Pigeon.LegacyFCM.Notification.html#remove?/1","title":"Pigeon.LegacyFCM.Notification.remove?/1","type":"function"},{"doc":"Returns a list of registration IDs that should be retried Examples iex&gt; n = % Pigeon.LegacyFCM.Notification { response : [ ...&gt; { :success , &quot;regid1&quot; } , { :invalid_registration , &quot;regid2&quot; } , ...&gt; { :success , &quot;regid3&quot; } , { :update , { &quot;regid4&quot; , &quot;new_regid4&quot; } } , ...&gt; { :not_registered , &quot;regid5&quot; } , { :unavailable , &quot;regid6&quot; } ] } iex&gt; retry? ( n ) [ &quot;regid6&quot; ]","ref":"Pigeon.LegacyFCM.Notification.html#retry?/1","title":"Pigeon.LegacyFCM.Notification.retry?/1","type":"function"},{"doc":"Returns a list of successful registration IDs Examples iex&gt; n = % Pigeon.LegacyFCM.Notification { response : [ ...&gt; { :success , &quot;regid1&quot; } , { :invalid_registration , &quot;regid2&quot; } , ...&gt; { :success , &quot;regid3&quot; } , { :update , { &quot;regid4&quot; , &quot;new_regid4&quot; } } , ...&gt; { :not_registered , &quot;regid5&quot; } , { :unavailable , &quot;regid6&quot; } ] } iex&gt; success? ( n ) [ &quot;regid1&quot; , &quot;regid3&quot; ]","ref":"Pigeon.LegacyFCM.Notification.html#success?/1","title":"Pigeon.LegacyFCM.Notification.success?/1","type":"function"},{"doc":"Returns a list of registration IDs and their corresponding new ID Examples iex&gt; n = % Pigeon.LegacyFCM.Notification { response : [ ...&gt; { :success , &quot;regid1&quot; } , { :invalid_registration , &quot;regid2&quot; } , ...&gt; { :success , &quot;regid3&quot; } , { :update , { &quot;regid4&quot; , &quot;new_regid4&quot; } } , ...&gt; { :not_registered , &quot;regid5&quot; } , { :unavailable , &quot;regid6&quot; } ] } iex&gt; update? ( n ) [ { &quot;regid4&quot; , &quot;new_regid4&quot; } ]","ref":"Pigeon.LegacyFCM.Notification.html#update?/1","title":"Pigeon.LegacyFCM.Notification.update?/1","type":"function"},{"doc":"","ref":"Pigeon.LegacyFCM.Notification.html#t:regid_error_response/0","title":"Pigeon.LegacyFCM.Notification.regid_error_response/0","type":"type"},{"doc":"LegacyFCM push response for individual registration IDs {:success, &quot;reg_id&quot;} - Push was successfully sent {:update, {&quot;reg_id&quot;, &quot;new_reg_id&quot;}} - Push successful but user should use new registration ID for future pushes {regid_error_response, &quot;reg_id&quot;} - Push attempted but server responded with error","ref":"Pigeon.LegacyFCM.Notification.html#t:regid_response/0","title":"Pigeon.LegacyFCM.Notification.regid_response/0","type":"type"},{"doc":"Status of LegacyFCM request :success - Notification was processed successfully :timeout - Worker did not respond within timeout. This is likely an internal error :unauthorized - Bad LegacyFCM key :malformed_json - Push payload was invalid JSON :internal_server_error - LegacyFCM server encountered an error while trying to process the request :unavailable - LegacyFCM server couldn't process the request in time","ref":"Pigeon.LegacyFCM.Notification.html#t:status/0","title":"Pigeon.LegacyFCM.Notification.status/0","type":"type"},{"doc":"","ref":"Pigeon.LegacyFCM.Notification.html#t:t/0","title":"Pigeon.LegacyFCM.Notification.t/0","type":"type"},{"doc":"","ref":"Pigeon.ConfigError.html","title":"Pigeon.ConfigError","type":"exception"}]